;**********************************************
;*          *
;**********************************************
;* :              ..              *
;*  :  MPLAB IDE v7.31         *
;* :         PIC16F676               *
;*  :                         *
;*    RC0,RC1,RC2,RC3,RC4,RC5,RA5 -      * 
;*         a,b,c,d,e,f,g     *
;*    RC0,RC1,RC2 -   UP,DN,MD    * 
;*    RC4,RA2,RA4 -   K2,K1,K0   *
;*    AN0  -           *
;*    RA1  -            *
;*    RST  -    VCC          *
;*                         kotov_ig@mail.ru   *
;**********************************************

          NOLIST
        #INCLUDE <P16F676.inc>
 __CONFIG _MCLRE_ON & _WDT_ON & _INTRC_OSC_NOCLKOUT & _PWRTE_ON & _BODEN & _CP_OFF & _CPD_OFF
            
         ERRORLEVEL 2
          
;                 FLAG  
; 0 -     / (1/0)      
; 1 -  /    (1/0) 
; 2 -  /    (1/0)  
; 3 -  - /   (1/0)  
 

;                 BUTTON  
; B'00000000' -      
; B'00000001' -    UP(SB1)       
; B'00000010' -    DN(SB2) 
; B'00000011' -    MD(SB3)   

;                 PICTER 
; B'00000000' -       
; B'00000001' -   uhi 
; B'00000010' -   ulo
; B'00000011' -   dlt
; B'00000100' -    
; B'00000101' -    
; B'00000110' -     
   
;  FSR  ,     
;  TMR1 ,   5
   
 	  CBLOCK 0x20
 	  	
 	INDUHI  : 0x03   ;  uhi
 	INDULO  : 0x03   ;  ulo
 	INDDLT  : 0x03   ;  dlt
 	U       : 0x02   ;    
 	INDU    : 0x03   ;       
 	UH               ;   
 	INDUH   : 0x03   ;  	 
 	UL               ;  
 	INDUL   : 0x03   ;   
 	DL               ;   
 	INDDL   : 0x03   ;   
 	FLAG             ;  
 	PICTER           ; 
 	PERIOD           ;,  0,25 
 	PRESKL           ;   0,25 
 	DELAY            ;  
 	WAIT             ;      
 	ALARM            ;    
 	BUTTON           ;  
 	BTNBUF           ;    
 	BTNUP            ;   UP(SB1)
 	BTNDN            ;   DN(SB2)
 	BTNMD            ;   MD(SB3)
          TASK             ; 
          ARGH             ; 
          ARGL  
	TMPH             ; 
	TMPL
	TMP
   	EETMP            ;   EEADR
   	FSRTMP           ;   FSR
	CNT              ;  
	 
 	  ENDC

         LIST

  	  ORG 0x00
   	B INIT 
            ORG 0x04
          B INTER
          
;******************************************************
;*            *
;******************************************************

INDTBL    ADDWF PCL           ;  
 	RETLW B'00111111'   ;0
	RETLW B'00000110'   ;1
	RETLW B'01011011'   ;2
	RETLW B'01001111'   ;3
          RETLW B'01100110'   ;4
	RETLW B'01101101'   ;5
          RETLW B'01111101'   ;6
	RETLW B'00000111'   ;7
          RETLW B'01111111'   ;8
	RETLW B'01101111'   ;9
	
;******************************************************
;*                     *
;******************************************************
		
STATETBL  ADDWF PCL       ;   
PICTER_INDU_BUTTON_XX     ;     
          MOVF UH,W       ;   
          SUBWF U+1,W     ;    
          SKPNC           ;PICTER << 0x05 + BUTTON << 0x03
          BSF FLAG,1      ; 28  
          BTFSC U,0       ;   RETLW  
          BSF FLAG,1      ;    
          B $+3           ;,    FSR
          NOP
PICTER_INDU_BUTTON_UP      
          B PICTER_INDU_BUTTON_XX 
          MOVF U+1,W
          SUBWF UL,W
          SKPNC
          BSF FLAG,1
          RETLW INDU
          NOP
          NOP
PICTER_INDU_BUTTON_DN
          B PICTER_INDU_BUTTON_XX
          NOP
          NOP
          NOP
          NOP
          NOP
          NOP
          NOP
PICTER_INDU_BUTTON_MD
          CLRF WAIT
          MOVLW 0x01
          MOVWF PICTER
          CLRF FLAG
          NOP
          NOP
          NOP
          RETLW INDUHI                
PICTER_INDUHI_BUTTON_XX
          INCFSZ WAIT
          RETLW INDUHI
          CLRF PICTER
          NOP
          NOP
          NOP
          NOP
          RETLW INDU
PICTER_INDUHI_BUTTON_UP
          CLRF WAIT
          MOVLW 0x02
          MOVWF PICTER
          NOP
          NOP
          NOP
          NOP
          RETLW INDULO
PICTER_INDUHI_BUTTON_DN
          CLRF WAIT
          MOVLW 0x03
          MOVWF PICTER
          NOP
          NOP
          NOP
          NOP
          RETLW INDDLT
PICTER_INDUHI_BUTTON_MD
          CLRF WAIT
          MOVLW 0x04
          MOVWF PICTER
          NOP
          NOP
          NOP
          NOP
          RETLW INDUH                           
PICTER_INDULO_BUTTON_XX
          INCFSZ WAIT
          RETLW INDULO
          CLRF PICTER
          NOP
          NOP
          NOP
          NOP
          RETLW INDU
PICTER_INDULO_BUTTON_UP
          CLRF WAIT
          MOVLW 0x03
          MOVWF PICTER
          NOP
          NOP
          NOP
          NOP
          RETLW INDDLT
PICTER_INDULO_BUTTON_DN
          CLRF WAIT
          MOVLW 0x01
          MOVWF PICTER
          NOP
          NOP
          NOP
          NOP
          RETLW INDUHI
PICTER_INDULO_BUTTON_MD
          CLRF WAIT
          MOVLW 0x05
          MOVWF PICTER
          NOP
          NOP
          NOP
          NOP
          RETLW INDUL                         
PICTER_INDDLT_BUTTON_XX
          INCFSZ WAIT
          RETLW INDDLT
          CLRF PICTER
          NOP
          NOP
          NOP
          NOP
          RETLW INDU
PICTER_INDDLT_BUTTON_UP
          CLRF WAIT
          MOVLW 0x01
          MOVWF PICTER
          NOP
          NOP
          NOP
          NOP
          RETLW INDUHI
PICTER_INDDLT_BUTTON_DN
          CLRF WAIT
          MOVLW 0x02
          MOVWF PICTER
          NOP
          NOP
          NOP
          NOP
          RETLW INDULO
PICTER_INDDLT_BUTTON_MD
          CLRF WAIT
          MOVLW 0x06
          MOVWF PICTER
          NOP
          NOP
          NOP
          NOP
          RETLW INDDL
PICTER_INDUH_BUTTON_XX
          INCFSZ WAIT
          RETLW INDUH
          CLRF PICTER
          MOVLW _UH
          MOVWF EETMP
          MOVF UH,W
          CALL EEWRITE
          RETLW INDU
PICTER_INDUH_BUTTON_UP
          CLRF WAIT
          MOVLW 0xFF
          SUBWF UH,W
          SKPZ
          INCF UH
          NOP  
          NOP
          RETLW INDUH
PICTER_INDUH_BUTTON_DN
          CLRF WAIT
          MOVLW 0xDE
          SUBWF UH,W
          SKPZ
          DECF UH
          NOP
          NOP
          RETLW INDUH
PICTER_INDUH_BUTTON_MD
          CLRF WAIT
          MOVLW 0x01
          MOVWF PICTER
          MOVLW _UH
          MOVWF EETMP
          MOVF UH,W
          CALL EEWRITE
          RETLW INDUHI
PICTER_INDUL_BUTTON_XX
          INCFSZ WAIT
          RETLW INDUL
          CLRF PICTER
          MOVLW _UL
          MOVWF EETMP
          MOVF UL,W
          CALL EEWRITE
          RETLW INDU
PICTER_INDUL_BUTTON_UP
          CLRF WAIT
          MOVLW 0xDA
          SUBWF UL,W
          SKPZ
          INCF UL
          NOP  
          NOP
          RETLW INDUL
PICTER_INDUL_BUTTON_DN
          CLRF WAIT
          MOVLW 0xAA
          SUBWF UL,W
          SKPZ
          DECF UL
          NOP
          NOP
          RETLW INDUL
PICTER_INDUL_BUTTON_MD
          CLRF WAIT
          MOVLW 0x02
          MOVWF PICTER
          MOVLW _UL
          MOVWF EETMP
          MOVF UL,W
          CALL EEWRITE
          RETLW INDULO         
PICTER_INDDL_BUTTON_XX
          INCFSZ WAIT
          RETLW INDDL
          CLRF PICTER
          MOVLW _DL
          MOVWF EETMP
          MOVF DL,W
          CALL EEWRITE
          RETLW INDU
PICTER_INDDL_BUTTON_UP
          CLRF WAIT
          MOVLW 0x1E
          SUBWF DL,W
          SKPZ
          INCF DL
          NOP 
          NOP
          RETLW INDDL
PICTER_INDDL_BUTTON_DN
          CLRF WAIT
          MOVLW 0x01
          SUBWF DL,W
          SKPZ
          DECF DL
          NOP
          NOP
          RETLW INDDL
PICTER_INDDL_BUTTON_MD
          CLRF WAIT
          MOVLW 0x03
          MOVWF PICTER
          MOVLW _DL
          MOVWF EETMP
          MOVF DL,W
          CALL EEWRITE
          RETLW INDDLT    
            
;******************************************************
;*                                   *
;******************************************************

INIT      CLRF PORTA
          CLRF PORTC
          MOVLW  0x07         ; 
          MOVWF CMCON
          BSF STATUS,RP0      ; 1
          CALL 0x03FF         ; 
          MOVWF OSCCAL
          MOVLW 0xFF          ;   
          MOVWF ADCON1        ;RC - 
          MOVLW B'10000000'   ;  
          MOVWF OPTION_REG    ; PORTA  
          MOVLW 0x10          ;  PORTA ,
          MOVWF TRISA         ; OUT -  
          CLRF TRISC          ;  PORTC  
          MOVLW 1<<ANS3       ; RA4   
          MOVWF ANSEL         ;   AN3
          CLRF VRCON          ;   
          CLRF WPUA
          BSF PIE1,TMR1IE     ;   TMR1 
          BCF STATUS,RP0      ; 0
          MOVLW B'00011100'   ; u
          MOVWF INDUHI
          MOVLW B'01110100'   ; h
          MOVWF INDUHI+1
          MOVLW B'00000100'   ; i
          MOVWF INDUHI+2
          MOVLW B'00011100'   ; u
          MOVWF INDULO
          MOVLW B'00111000'   ; l
          MOVWF INDULO+1
          MOVLW B'01011100'   ; o
          MOVWF INDULO+2
          MOVLW B'01011110'   ; d
          MOVWF INDDLT
          MOVLW B'00111000'   ; l
          MOVWF INDDLT+1
          MOVLW B'01111000'   ; t
          MOVWF INDDLT+2 
          MOVLW INDUH         ;   
          MOVWF FSR           ;  UH,UL,DL  
          MOVLW _UH           ; EEPROM  ,
          MOVWF EETMP         ;   
          CALL EEREAD         ; 
          MOVWF UH            ;  EEREAD  
          MOVWF ARGL          ; EEPROM _UH,_UL,_DL 
          CLRF ARGH           ; EETMP
          CALL BINDEC         ; BINDEC  -
          MOVLW INDUL         ;  
          MOVWF FSR           ;  ARGH:ARGL,
          MOVLW _UL           ;     
          MOVWF EETMP         ;  FSR
          CALL EEREAD
          MOVWF UL
          MOVWF ARGL
          CLRF ARGH
          CALL BINDEC
          MOVLW INDDL
          MOVWF FSR
          MOVLW _DL
          MOVWF EETMP
          CALL EEREAD
          MOVWF DL
          MOVWF ARGL
          CLRF ARGH
          CALL BINDEC
          CALL ADCONVER
          MOVF U+1,W
          MOVWF ARGL
          MOVF U,W
          MOVWF ARGH
          MOVLW INDU
          MOVWF FSR
          CALL BINDEC
          CLRF ALARM
          CLRF PERIOD
          CLRF TASK
          CLRF PICTER
          CLRF ARGL
          CLRF ARGH
          CLRF BTNUP
          CLRF BTNDN
          CLRF BTNMD
          CLRF BUTTON
          CLRF FLAG 
          MOVLW INDU
          MOVWF FSR
          BSF T1CON,TMR1ON    ;TMR1              
          MOVLW (1<<GIE)|(1<<PEIE)
          MOVWF INTCON        ;  
          B $
          
;******************************************************
;*                *
;******************************************************	             

INTER     BCF PIR1,TMR1IF      ;  TMR1IF
          MOVLW 0xEC           ;  TMR1
          MOVWF TMR1H          ;   5
          MOVLW 0x82
          MOVWF TMR1L
          CLRWDT
          INCF PRESKL          ;    
          MOVLW 0x32           ;
          SUBWF PRESKL,W       ; PRESKL  
          SKPZ                 ;   
          B $+0x0D             ;    50
          CLRF PRESKL          ;(..  50*5 = 250) 
          INCF PERIOD          ;    
          MOVLW 0x04           ; PERIOD
          ANDWF PERIOD,W       ;  3-  PERIOD
          BCF PERIOD,2         ;(..  4*250 = 1) 
          SKPZ                 ;  DELAY
          MOVLW 0x01           ;  DELAY=0 
          MOVF DELAY           ;  
          SKPZ
          SUBWF DELAY
          SKPNZ
          BCF FLAG,0
          MOVF TASK            ;   
          SKPNZ                ;   
          B SIMBOL0            ;    ,
          DECF TASK            ;    50
          SKPNZ
          B SIMBOL1 
          DECF TASK
          SKPNZ
          B SIMBOL2
          B BTNPRES
SIMBOL0   MOVLW 0x01            ;        
          MOVWF TASK
          BTFSS FLAG,2
          B $+0x0A
          BTFSS FLAG,0
          B $+6
          BTFSC PERIOD,1
          B $+6
          MOVLW 0xF4
          MOVWF PORTC
          RETFIE
          BTFSS PERIOD,0
          B $-4
          INCF FSR
          INCF FSR
          MOVF INDF,W
          MOVWF TMPL
          ANDLW 0x07
          MOVWF TMPH
          DECF FSR
          DECF FSR
          MOVF PORTA,W
          ANDLW 0xF8
          IORWF TMPH
          RRF TMPL
          RRF TMPL
          RRF TMPL,W
          ANDLW 0x0F
          IORLW 0xE0
          BSF STATUS,RP0
          BCF TRISC,2
          BTFSS TMPL,3
          BSF TRISC,2
          BCF STATUS,RP0
          MOVWF PORTC
          MOVF TMPH,W
          MOVWF PORTA
          RETFIE
SIMBOL1   MOVLW 0x02            ;    
          MOVWF TASK
          BTFSS FLAG,2
          B $+0x0A
          BTFSS FLAG,0
          B $+6
          BTFSC PERIOD,1
          B $+6
          MOVLW 0xF4
          MOVWF PORTC
          RETFIE
          BTFSS PERIOD,0
          B $-4
          INCF FSR
          MOVF INDF,W
          MOVWF TMPL
          ANDLW 0x07
          MOVWF TMPH
          DECF FSR
          MOVF PORTA,W
          ANDLW 0xF8
          IORWF TMPH
          RRF TMPL
          RRF TMPL
          RRF TMPL,W
          ANDLW 0x0F
          IORLW 0xD0
          BSF STATUS,RP0
          BCF TRISC,2
          BTFSS TMPL,3
          BSF TRISC,2
          BCF STATUS,RP0
          MOVWF PORTC
          MOVF TMPH,W
          MOVWF PORTA
          RETFIE         
SIMBOL2   MOVLW 0x03             ;    
          MOVWF TASK
          BTFSS FLAG,2
          B $+0x0A
          BTFSS FLAG,0
          B $+6
          BTFSC PERIOD,1
          B $+6
          MOVLW 0xF4
          MOVWF PORTC
          RETFIE
          BTFSS PERIOD,0
          B $-4
          MOVF INDF,W
          MOVWF TMPL
          ANDLW 0x07
          MOVWF TMPH
          MOVF PORTA,W
          ANDLW 0xF8
          IORWF TMPH
          RRF TMPL
          RRF TMPL
          RRF TMPL,W
          ANDLW 0x0F
          IORLW 0xF0
          BSF STATUS,RP0
          BCF TRISC,2
          BCF STATUS,RP0
          MOVWF PORTC
          MOVF TMPH,W
          MOVWF PORTA
          RETFIE                
BTNPRES   CLRF TASK            ;  
	MOVF FSR,W          
	MOVWF FSRTMP
          CALL ADCONVER        ; 
          MOVLW INDU
  	MOVWF FSR
	MOVF U,W
          MOVWF ARGH 
          MOVF U+1,W
          MOVWF ARGL
	CALL BINDEC          ; 
	MOVF FSRTMP,W
  	MOVWF FSR
          CALL BTNPOL          ;         
          MOVWF BUTTON 
          SWAPF BUTTON
          CLRC
          RRF BUTTON
          SWAPF PICTER
          CLRC
          RLF PICTER,W
          SWAPF PICTER
          IORWF BUTTON,W
          CLRF BUTTON
          CALL STATETBL         ; 
          MOVWF FSR             ;  
          INCF ALARM            ;   
          BTFSS FLAG,1          ;  
          CLRF ALARM            ;  ALARM 
          BCF FLAG,1            ;    ALARM=5,
          MOVF ALARM,W          ;   
          SUBLW 0x05
          SKPZ
          B $+7
          BCF PORTA,5
          BCF FLAG,0
          BSF FLAG,2
          BSF FLAG,3
          DECF ALARM
          B $+0x0D
          BTFSC FLAG,3
          BSF FLAG,0
          MOVF DL,W
          BTFSC FLAG,3
          MOVWF DELAY
          BTFSC FLAG,3
          CLRF ALARM
          BCF FLAG,3
          BTFSS FLAG,0
          BSF PORTA,5
          BTFSS FLAG,0
          BCF FLAG,2
          CLRF ARGH
          MOVF UH,W
          MOVWF ARGL  
          MOVLW INDUH
          SUBWF FSR,W
          SKPZ
          B $+3
          CALL BINDEC
          RETFIE
          MOVF UL,W
          MOVWF ARGL 
          MOVLW INDUL
          SUBWF FSR,W  
          SKPZ
          B $+3
          CALL BINDEC
          RETFIE
          MOVF DL,W
          MOVWF ARGL  
          MOVLW INDDL
          SUBWF FSR,W
          SKPZ
          B $+3
          CALL BINDEC
          RETFIE
          MOVF U,W
          MOVWF ARGH 
          MOVF U+1,W
          MOVWF ARGL  
          MOVLW INDU
          SUBWF FSR,W
          SKPNZ
          CALL BINDEC
          RETFIE
          
;******************************************************
;*                            *
;******************************************************
	         
BTNPOL   	BSF STATUS,RP0         ;  
          MOVLW 0xFF             ;   PA0-PA2  BTNBUF
          MOVWF TRISC            ;  
	MOVLW 0x1F             ; SB1,SB2,SB3(UP,DN,MD)
	MOVWF TRISA            ; 
	MOVLW 0x07             ;  BTNUP,BTNDN,
	MOVWF WPUA             ;BTNMD 
	CLRF OPTION_REG        ;    
	BCF STATUS,RP0         ;  RETLW 
	MOVF PORTA,W
	ANDLW 0x07
	MOVWF BTNBUF
	BSF STATUS,RP0
	CLRF TRISC
	MOVLW 0x10
	MOVWF TRISA
	BSF OPTION_REG,NOT_RAPU
	CLRF WPUA
	BCF STATUS,RP0
	MOVLW 0x00
	RRF BTNBUF
	SKPC
	ADDLW 0x01
	RRF BTNBUF
	SKPC
	ADDLW 0x01
	RRF BTNBUF
	SKPC
	ADDLW 0x01
	XORLW 0x01
	SKPNZ
	B $+5
	CLRF BTNUP
	CLRF BTNDN
	CLRF BTNMD
	RETLW 0x00
	SKPNC
	B $+0x10
	CLRF BTNUP
	CLRF BTNDN
	INCF BTNMD
	MOVLW 0x08
	XORWF BTNMD,W
	SKPNZ
	RETLW 0x03
	MOVLW 0x8F
	ANDWF BTNMD,W
	XORLW 0x88
          MOVLW 0x80
	SKPZ
	RETLW 0x00
	MOVWF BTNMD
	RETLW 0x03 
	RLF BTNBUF
          SKPNC
	B $+0x10
	CLRF BTNUP
	CLRF BTNMD
	INCF BTNDN
	MOVLW 0x08
	XORWF BTNDN,W
	SKPNZ
	RETLW 0x02
	MOVLW 0x8F
	ANDWF BTNDN,W
	XORLW 0x88
	MOVLW 0x80
	SKPZ
	RETLW 0x00
	MOVWF BTNDN
	RETLW 0x02 	
	CLRF BTNMD
	CLRF BTNDN
	INCF BTNUP
	MOVLW 0x08
	XORWF BTNUP,W
	SKPNZ
	RETLW 0x01
	MOVLW 0x8F
	ANDWF BTNUP,W
	XORLW 0x88
	MOVLW 0x80
	SKPZ
	RETLW 0x00
	MOVWF BTNUP
	RETLW 0x01 
	
;******************************************************
;*     *
;****************************************************** 
          
EEWRITE   BSF STATUS,RP0         ;   
	MOVWF EEDAT            ; W,     EETMP
	MOVF EETMP,W
          MOVWF EEADR
	BSF EECON1,WREN
	MOVLW 0x55
	MOVWF EECON2    
          MOVLW 0xAA
	MOVWF EECON2 
          BSF EECON1,WR
	BTFSC EECON1,EEIF
	B $-1
	BCF EECON1,EEIF
          BCF EECON1,WREN	 
	BCF STATUS,RP0
          RETURN
          
;******************************************************
;*        *
;****************************************************** 
          
EEREAD    BSF STATUS,RP0          ;  
          MOVF EETMP,W            ; W,     EETMP
          MOVWF EEADR
	BSF EECON1,RD
	MOVF EEDATA,W   
          BCF STATUS,RP0
	RETURN
	
;******************************************************
;*                     *
;****************************************************** 	

ADCONVER  MOVLW (1<<ADFM)|(1<<ADON)|(1<<CHS1)|(1<<CHS0)
	MOVWF ADCON0              
	CALL D100uS
	BSF ADCON0,GO
	BTFSC ADCON0,GO_DONE 
	B $-1
	MOVF ADRESH,W
	MOVWF U
	BSF STATUS,RP0
	MOVLW U+1
	MOVWF FSR
	MOVF ADRESL,W
	MOVWF INDF
	BCF STATUS,RP0
	CLRC
	RRF U
	RRF U+1
          RETURN
          
;******************************************************
;*    -     *
;****************************************************** 
         
BINDEC    CLRF TMPL              ;   
          CLRF TMPH              ;   ARGH:ARGL
          MOVLW 0x10             ;   
          MOVWF CNT              ;    INDTBL 
BD1       RLF ARGL               ;   
          RLF ARGH               ;     FSR
          RLF TMPL
          RLF TMPH
          DECFSZ CNT
          B BD2
          MOVLW 0x0F
          ANDWF TMPH,W
          CALL INDTBL
          MOVWF INDF
          MOVLW 0x3F
          SUBWF INDF,W
          SKPNZ
          CLRF INDF
          INCF FSR
          SWAPF TMPL,W
          ANDLW 0x0F
          CALL INDTBL
          MOVWF INDF
          INCF FSR
          MOVLW 0x0F
          ANDWF TMPL,W
          CALL INDTBL
          MOVWF INDF
          DECF FSR
          DECF FSR
          RETURN
BD2       MOVLW 0x03
          ADDWF TMPL,W 
          MOVWF TMP
          BTFSC TMP,3
          MOVWF TMPL
          MOVLW 0x30
          ADDWF TMPL,W 
          MOVWF TMP
          BTFSC TMP,7
          MOVWF TMPL                                        
          MOVLW 0x03
          ADDWF TMPH,W 
          MOVWF TMP
          BTFSC TMP,3
          MOVWF TMPH
          MOVLW 0x30
          ADDWF TMPH,W 
          MOVWF TMP
          BTFSC TMP,7
          MOVWF TMPH      
          B BD1
          
;******************************************************
;*              100            *
;****************************************************** 
         
 D100uS   MOVLW 0x19
          ADDLW 0xFF
          SKPZ
          B $-2
    	RETURN
    	
           ORG 0x2100
          
      _UH    DE   0xFF   ;   255
      _UL    DE   0xAA   ;   170
      _DL    DE   0x0A   ;    10
          
           END	
          

